// ----------------------------------------------------------------------------
// A contour stream holds contour levels calculated from NMR data.
//
#ifndef CONTOURSTREAM_HEADER_INCLUDED
#define CONTOURSTREAM_HEADER_INCLUDED

#include <stdlib.h>		// use size_t

class Drawing_Routines;

class ContourStream {
public:
			ContourStream();
			~ContourStream();

	void		addContour(float lev, int n, float *x, float *y);
	void		free_extra_memory();
	size_t		memory_use() const;

	void		display(Drawing_Routines &dr);

private:
	int		mSize;			// maximum memory size
	int		mUsed;			// current memory size
	float		*mStream;		// allocated memory

	float		*_allocate(int floats);	// allocate memory
	void		resize_array(int size);
};

#endif
